#include<stdio.h>
#include<stdlib.h>
#include<time.h>

#define NUMBER_OF_ELEMENTS 20

int array[NUMBER_OF_ELEMENTS];


int find_min(int *array)
{
    int min;
    unsigned int i;
    min=array[0];
    for(i=1; i<NUMBER_OF_ELEMENTS; i++)
        if(min>array[i])
            min=array[i];
    return min;
}

int find_max(int *array)
{
    int max;
    unsigned int i;
    max=array[0];
    for(i=1; i<NUMBER_OF_ELEMENTS; i++)
        if(max<array[i])
            max=array[i];
    return max;
}

void find_exterme_values(int array[], int *min, int *max)
{
    unsigned int i;
    *max = *min = array[0];
    for(i=1; i<NUMBER_OF_ELEMENTS; i++) {
        if(*min>array[i])
            *min=array[i];
        if(*max<array[i])
            *max=array[i];
    }
}

int find_value_index(int array[], int value)
{
    unsigned int i;
    for(i=0; i<NUMBER_OF_ELEMENTS; i++) {
        if(array[i]==value)
            return i;
    }
    return -1;
}

void print_array(int array[], const unsigned int length)
{
    unsigned int i;
    for(i=0; i<length; i++)
        printf("%d ",array[i]);
    puts("");
}

void fill_array(int array[], const unsigned int length)
{
    for(int i=0; i<length; i++)
        array[i] = i;
}

int choose(int from, const unsigned int length)
{
    return from+rand()%(length-from);
}

void swap(int *first, int *second)
{
    if(first!=second) {
        *first ^= *second;
        *second ^= *first;
        *first ^= *second;
    }
}

void shuffle(int array[], const unsigned int length)
{
    srand(time(0));
    unsigned int i;
    for(i=0; i<length-1; i++)
        swap(&array[i],&array[choose(i, length)]);
}


void selection_sort(int array[])
{
    int i,j;

    for(i=0; i<NUMBER_OF_ELEMENTS-1; i++) {
        int min = i;
        for(j=i+1; j<NUMBER_OF_ELEMENTS; j++)
            if(array[min]>array[j])
                min = j;
        if(min!=i)
            swap(&array[min],&array[i]);
    }
}

int binary_search(int array[], int value)
{
    int down=0, up=NUMBER_OF_ELEMENTS-1;

    while(down<=up) {
        int middle = down+((up-down)/2);
        if(array[middle]==value)
            return middle;
        if(array[middle]<value) {
            down = middle + 1;
            continue;
        }
        if(array[middle]>value)
            up = middle - 1;
    }
    return -1;
}

int find_minimum(int array[])
{
    return array[0];
}

int find_maximum(int array[])
{
    return array[NUMBER_OF_ELEMENTS-1];
}

int main(void)
{
    fill_array(array, NUMBER_OF_ELEMENTS);
    shuffle(array,NUMBER_OF_ELEMENTS);
    print_array(array, NUMBER_OF_ELEMENTS);
    printf("Wartość minimalna w tablicy: %d\n",find_min(array));
    printf("Wartość maksymalna w tablicy: %d\n",find_max(array));
    int min = 0, max = 0;
    find_exterme_values(array, &min, &max);
    printf("Wartość minimalna w tablicy: %d\n",min);
    printf("Wartość maksymalna w tablicy: %d\n",max);
    puts("Jaką wartość wyszukać?");
    int value = 0;
    scanf("%d",&value);
    int index = find_value_index(array, value);
    if(index!=-1)
        printf("Wartość %d znajduje się w elemencie o indeksie %d.\n",value,index);
    else
        puts("Nie ma takiej wartości w tablicy.");
    selection_sort(array);
    print_array(array,NUMBER_OF_ELEMENTS);
    printf("Wartość minimalna w tablicy: %d\n",find_minimum(array));
    printf("Wartość maksymalna w tablicy: %d\n",find_maximum(array));
    puts("Jaką wartość wyszukać?");
    scanf("%d",&value);
    index = binary_search(array,value);
    if(index!=-1)
        printf("Wartość %d znajduje się w elemencie o indeksie %d.\n",value,index);
    else
        puts("Nie ma takiej wartości w tablicy.");
    return 0;
}
